Vue Data Grid

ApexGrid is a Lit web component, so it works in Vue 3 as a custom element. This guide covers the Vite setup, property binding, imperative access, and events.

Installation

npm install apex-grid

Vite configuration

Tell Vue's template compiler to treat ApexGrid (and its sub-components) as custom elements, so it does not try to resolve them as Vue components. With Vite:

import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [
    vue({
      template: {
        compilerOptions: {
          // treat all tags with a dash as custom elements
          isCustomElement: (tag) => tag.includes('-'),
        },
      },
    }),
  ],
})

Usage

Register the element once with the side-effect import apex-grid/define, then use <apex-grid> in your template. Use the .prop modifier so Vue binds arrays and objects as JavaScript properties rather than HTML attributes.

<script setup>
import 'apex-grid/define'

const users = [
  { id: 1, name: 'Alice', email: 'alice@example.com' },
  { id: 2, name: 'Bob',   email: 'bob@example.com' },
]

const columns = [
  { key: 'id',    headerText: 'ID',    type: 'number' },
  { key: 'name',  headerText: 'Name',  sort: true, filter: true },
  { key: 'email', headerText: 'Email', sort: true },
]
</script>

<template>
  <apex-grid :columns.prop="columns" :data.prop="users"></apex-grid>
</template>

Binding complex data

When binding complex data such as objects and arrays, use the .prop modifier so Vue sets a DOM property instead of a (stringified) attribute:

<apex-grid :columns.prop="columns" :data.prop="users"></apex-grid>

See the Vue guide on passing DOM properties for more.

Accessing the grid imperatively

Put a template ref on the element to get the underlying DOM node, then call grid methods on it after mount:

<script setup>
import { ref, onMounted } from 'vue'
import 'apex-grid/define'
import type { ApexGrid } from 'apex-grid'

const gridEl = ref<ApexGrid>()

const users = [
  { id: 1, name: 'Alice', email: 'alice@example.com' },
  { id: 2, name: 'Bob',   email: 'bob@example.com' },
]
const columns = [
  { key: 'id',   headerText: 'ID',   type: 'number' },
  { key: 'name', headerText: 'Name', sort: true },
]

onMounted(() => {
  const grid = gridEl.value
  grid?.sort({ key: 'name', direction: 'ascending' })
})
</script>

<template>
  <apex-grid ref="gridEl" :columns.prop="columns" :data.prop="users"></apex-grid>
</template>

Listening to events

ApexGrid dispatches its events as native CustomEvents. The most reliable way to handle them in Vue is to attach a listener on the element ref in onMounted, reading the payload from event.detail:

<script setup>
import { ref, onMounted } from 'vue'
import 'apex-grid/define'
import type { ApexGrid } from 'apex-grid'

const gridEl = ref<ApexGrid>()

onMounted(() => {
  const grid = gridEl.value
  grid?.addEventListener('rowSelected', (e) => {
    console.log('selected:', (e as CustomEvent).detail)
  })
  grid?.addEventListener('sorted', (e) => {
    console.log('sorted:', (e as CustomEvent).detail)
  })
})
</script>

<template>
  <apex-grid ref="gridEl" :columns.prop="columns" :data.prop="users"></apex-grid>
</template>

Template v-on binding also works in a build setup (SFC templates preserve the event-name case), for example @rowSelected="onRowSelected". The event name is case-sensitive, so match it exactly; the addEventListener approach above avoids any casing ambiguity.

Commonly used events dispatched by ApexGrid (the -ing / -Changing variants fire before the operation and are cancellable; see the React guide for the complete list):

EventDetail
rowSelectedThe selected row data
cellValueChangedUpdated cell value and row data
sortedActive sort expression
filteredActive filter state
pageChangedNew page index and size

React Data Grid

ApexGrid works with React as a web component. The @lit/react package provides a wrapper that bridges Lit events to React's synthetic event system.

Installation

npm install apex-grid @lit/react

@lit/react is the current package name. The older @lit-labs/react was the preview name and is now deprecated.

Create a typed wrapper

Use createComponent from @lit/react to wrap the element. The factory function pattern below preserves the TypeScript generics on the grid's data and columns props.

// apex-grid-wrapper.tsx
import React from 'react'
import { createComponent } from '@lit/react'
import { ApexGrid, ColumnConfiguration } from 'apex-grid'

ApexGrid.register()

export function createApexGrid<T extends object>() {
  return createComponent({
    tagName: 'apex-grid',
    elementClass: ApexGrid<T>,
    react: React,
    events: {
      onRowSelected:      'rowSelected',
      onRowSelecting:     'rowSelecting',
      onCellValueChanged: 'cellValueChanged',
      onFiltered:         'filtered',
      onSorted:           'sorted',
      onPageChanged:      'pageChanged',
    },
  })
}

Usage

Call the factory once per data type at module scope, then use the resulting component like any React component.

// App.tsx
import { createApexGrid } from './apex-grid-wrapper'
import { ColumnConfiguration } from 'apex-grid'

interface User {
  id: number
  name: string
  email: string
}

const UserGrid = createApexGrid<User>()

export default function App() {
  const data: User[] = [
    { id: 1, name: 'Alice', email: 'alice@example.com' },
    { id: 2, name: 'Bob',   email: 'bob@example.com' },
  ]

  const columns: ColumnConfiguration<User>[] = [
    { key: 'id',    headerText: 'ID',    type: 'number' },
    { key: 'name',  headerText: 'Name',  sort: true, filter: true },
    { key: 'email', headerText: 'Email', sort: true },
  ]

  return (
    <UserGrid
      data={data}
      columns={columns}
      onRowSelected={(e) => console.log('selected:', e.detail)}
    />
  )
}

Imperative access

Use a ref to call grid methods directly. Pass the ref to the wrapped component using the standard React ref prop.

import { useRef, useEffect } from 'react'
import { createApexGrid } from './apex-grid-wrapper'
import { ApexGrid, ColumnConfiguration } from 'apex-grid'

interface User {
  id: number
  name: string
  email: string
}

const UserGrid = createApexGrid<User>()

export default function App() {
  const gridRef = useRef<ApexGrid<User>>(null)

  const data: User[] = [
    { id: 1, name: 'Alice', email: 'alice@example.com' },
    { id: 2, name: 'Bob',   email: 'bob@example.com' },
  ]

  const columns: ColumnConfiguration<User>[] = [
    { key: 'id',    headerText: 'ID',    type: 'number' },
    { key: 'name',  headerText: 'Name',  sort: true },
    { key: 'email', headerText: 'Email' },
  ]

  useEffect(() => {
    gridRef.current?.sort({ key: 'name', direction: 'ascending' })
  }, [])

  return (
    <UserGrid
      ref={gridRef}
      data={data}
      columns={columns}
    />
  )
}

Available events

The events map passed to createComponent controls which custom events become React props: add an onX: 'domEventName' entry for each event you want to handle (the example above wires the six most common). ApexGrid dispatches the following events.

Events emitted before an operation (the -ing / -Changing variants) are cancellable: call e.detail's cancellation or e.preventDefault() to stop the operation, and you can modify the expression before it runs.

Suggested propDOM eventCancellableFires
onRowSelectingrowSelectingyesBefore the row selection set changes
onRowSelectedrowSelectedAfter row selection changes
onCellValueChangingcellValueChangingyesBefore a cell value is committed
onCellValueChangedcellValueChangedAfter a cell value is committed
onCellValidationFailedcellValidationFailedA candidate cell value was rejected by validators
onRowEditStartedrowEditStartedA row entered edit mode (row edit mode)
onRowEditEndedrowEditEndedA row left edit mode (committed reports whether it saved)
onSortingsortingyesBefore a sort is applied
onSortedsortedAfter a sort is applied
onFilteringfilteringyesBefore a filter is applied
onFilteredfilteredAfter a filter is applied
onQuickFilterChangingquickFilterChangingyesBefore the quick-filter value is applied
onQuickFilterChangedquickFilterChangedAfter the quick filter is applied
onPageChangingpageChangingyesBefore a page or page-size change
onPageChangedpageChangedAfter a page or page-size change
onColumnPinningcolumnPinningyesBefore a column's pin position changes
onColumnPinnedcolumnPinnedAfter a column's pin position changes
onColumnMovingcolumnMovingyesBefore a column moves
onColumnMovedcolumnMovedAfter a column moves
onRowPinningrowPinningyesBefore a row is pinned, moved between bands, or unpinned
onRowPinnedrowPinnedAfter a row's pin state changes
onRowMovingrowMovingyesBefore a row moves
onRowMovedrowMovedAfter a row moves
onRowExpandingrowExpandingyesBefore the row-expansion set changes
onRowExpandedrowExpandedAfter a row-expansion change
onTreeRowExpandingtreeRowExpandingyesBefore the tree-row expansion set changes
onTreeRowExpandedtreeRowExpandedAfter a tree-row expansion change
onHistoryChangedhistoryChangedAfter the undo / redo stacks change
onStateChangedstateChangedAfter the grid's state changes (debounced)

Each handler receives the CustomEvent; read e.detail for the payload (typed per event, e.g. ApexRowSelectedEvent<T>, SortExpression<T>).

Angular Data Grid

ApexGrid is a Lit web component that works with Angular through the CUSTOM_ELEMENTS_SCHEMA or standalone component imports.

Installation

npm install apex-grid

Standalone component setup (Angular 15+, recommended)

Declare CUSTOM_ELEMENTS_SCHEMA on the component itself and register the element before first render.

// app.component.ts
import { Component, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core'
import { ApexGrid, ColumnConfiguration } from 'apex-grid'

ApexGrid.register()

interface User {
  id: number
  name: string
  email: string
  role: string
}

@Component({
  selector: 'app-root',
  standalone: true,
  schemas: [CUSTOM_ELEMENTS_SCHEMA],
  template: `
    <apex-grid
      [data]="users"
      [columns]="columns"
    ></apex-grid>
  `
})
export class AppComponent {
  users: User[] = [
    { id: 1, name: 'Alice', email: 'alice@example.com', role: 'Admin' },
    { id: 2, name: 'Bob',   email: 'bob@example.com',   role: 'Editor' },
  ]

  columns: ColumnConfiguration<User>[] = [
    { key: 'id',    headerText: 'ID',    type: 'number' },
    { key: 'name',  headerText: 'Name',  sort: true, filter: true },
    { key: 'email', headerText: 'Email', sort: true },
    { key: 'role',  headerText: 'Role',  type: 'select',
      options: ['Admin', 'Editor', 'Viewer'] },
  ]
}

NgModule setup (Angular 14 and earlier)

Add CUSTOM_ELEMENTS_SCHEMA to the schemas array of the root module, then register the element in the component file.

// app.module.ts
import { NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { AppComponent } from './app.component'

@NgModule({
  declarations: [AppComponent],
  imports: [BrowserModule],
  schemas: [CUSTOM_ELEMENTS_SCHEMA],
  bootstrap: [AppComponent]
})
export class AppModule {}
// app.component.ts
import { Component } from '@angular/core'
import { ApexGrid, ColumnConfiguration } from 'apex-grid'

ApexGrid.register()

interface User {
  id: number
  name: string
  email: string
}

@Component({
  selector: 'app-root',
  template: `
    <apex-grid
      [data]="users"
      [columns]="columns"
    ></apex-grid>
  `
})
export class AppComponent {
  users: User[] = [
    { id: 1, name: 'Alice', email: 'alice@example.com' },
    { id: 2, name: 'Bob',   email: 'bob@example.com' },
  ]

  columns: ColumnConfiguration<User>[] = [
    { key: 'id',    headerText: 'ID',    type: 'number' },
    { key: 'name',  headerText: 'Name',  sort: true, filter: true },
    { key: 'email', headerText: 'Email', sort: true },
  ]
}

Binding complex data

Angular property binding uses [property] for objects and arrays. The [data] and [columns] bindings pass values as JavaScript properties on the element, not as HTML attributes. This is the correct approach for web components that accept arrays and objects.

Accessing the grid imperatively

Use ViewChild to get a reference to the native element and call grid methods directly.

import { Component, ViewChild, ElementRef, AfterViewInit, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core'
import { ApexGrid, ColumnConfiguration } from 'apex-grid'

ApexGrid.register()

interface User {
  id: number
  name: string
  email: string
}

@Component({
  selector: 'app-root',
  standalone: true,
  schemas: [CUSTOM_ELEMENTS_SCHEMA],
  template: `
    <apex-grid
      #grid
      [data]="users"
      [columns]="columns"
    ></apex-grid>
  `
})
export class AppComponent implements AfterViewInit {
  @ViewChild('grid') gridEl!: ElementRef<ApexGrid<User>>

  users: User[] = [
    { id: 1, name: 'Alice', email: 'alice@example.com' },
    { id: 2, name: 'Bob',   email: 'bob@example.com' },
  ]

  columns: ColumnConfiguration<User>[] = [
    { key: 'id',    headerText: 'ID',    type: 'number' },
    { key: 'name',  headerText: 'Name',  sort: true },
    { key: 'email', headerText: 'Email' },
  ]

  ngAfterViewInit() {
    this.gridEl.nativeElement.sort({ key: 'name', direction: 'ascending' })
  }
}

Listening to events

Angular's (eventName) template binding does fire for custom DOM events dispatched by web components: Angular attaches a real DOM listener for any binding that is not a directive output, so a CustomEvent('rowSelected') reaches (rowSelected). Bind directly in the template and read the payload from $event.detail.

@Component({
  standalone: true,
  schemas: [CUSTOM_ELEMENTS_SCHEMA],
  template: `
    <apex-grid
      [data]="users"
      [columns]="columns"
      (rowSelected)="onRowSelected($event)"
      (sorted)="onSorted($event)"
    ></apex-grid>
  `,
})
export class AppComponent {
  onRowSelected(e: Event) {
    console.log('selected:', (e as CustomEvent).detail)
  }
  onSorted(e: Event) {
    console.log('sorted:', (e as CustomEvent).detail)
  }
}

The binding name is case-sensitive and must match the event exactly ((rowSelected), not (rowselected)). As an alternative, for example when the event name is dynamic, attach a listener imperatively via ViewChild in ngAfterViewInit:

ngAfterViewInit() {
  this.gridEl.nativeElement.addEventListener('rowSelected', (e: Event) => {
    console.log('selected:', (e as CustomEvent).detail)
  })
}

Commonly used events dispatched by ApexGrid (the -ing / -Changing variants fire before the operation and are cancellable; see the React guide for the complete list):

EventDetail
rowSelectedThe selected row data
rowSelectingThe row data about to be selected
cellValueChangedUpdated cell value and row data
filteredActive filter expression tree
sortedActive sort expression
pageChangedNew page index